      /IF NOT DEFINED(WSDL2RPG_WS_STUB_COMMON_TYPES)
      /DEFINE WSDL2RPG_WS_STUB_COMMON_TYPES
      *
      *=====================================================================*
      *  HTTP API
      *=====================================================================*
     D HTTP_API_DEFAULT_LOG_FILE...
     D                 C                   '/tmp/httpapi_debug.txt'
      *
      *=====================================================================*
      *  WSDL2RPG: Public Type Definitions of Generated Web Service Stubs
      *=====================================================================*
      *
      *   Messages:
      /COPY QWSDL2RPG,USR0030                      Unexpected HTML data received from ...
      /COPY QWSDL2RPG,USR0042                      Unexpected element received from web ...
      /COPY QWSDL2RPG,USR0048                      Failed to get login credentials. ...
      *
      *   Character translation:
     D wsdl_hTranscoder_t...
     D                 S               *                           based(pDummy)
      *
      *   Dynamic arrays:
     D wsdl_hArray_t   S               *                           based(pDummy)
     D wsdl_arrayName_t...
     D                 S            128A   varying                 based(pDummy)
      *
      *   Web Service error message:
     D wsdl_errText_t...
     D                 S            128A   varying                 based(pDummy)
      *
      *   SOAP types:
     D wsdl_http_ErrorNo_t...
     D                 S             10I 0                         based(pDummy)
      *
     D wsdl_http_ErrorText_t...
     D                 S            128A   varying                 based(pDummy)
      *
     D wsdl_soap_faultCode_t...
     D                 S            256A   varying                 based(pDummy)
      *
     D wsdl_soap_faultstring_t...
     D                 S            256A   varying                 based(pDummy)
      *
     D wsdl_soapAction_t...
     D                 S            510A   varying                 based(pDummy)
      *
      *   XML types:
     D wsdl_xml_ErrorNo_t...
     D                 S             10I 0                         based(pDummy)
      *
     D wsdl_xml_ErrorText_t...
     D                 S            256A   varying                 based(pDummy)
     D wsdl_xml_line_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_xml_column_t...
     D                 S             10I 0                         based(pDummy)
      *
      *   Constants:
     D WSDL_HTTP_SUCCESS...
     D                 C                   1
     D WSDL_HTTP_ERROR...
     D                 C                   0
     D WSDL_HTTP_ERROR_UNEXPECTED...
     D                 C                   -1
     D WSDL_HTTP_ERROR_SOAP...
     D                 C                   -2
     D WSDL_HTTP_ERROR_UNKNOWN...
     D                 C                   -3
      *
     D WSDL_SUCCESS...
     D                 C                   1
     D WSDL_ERROR...
     D                 C                   0
      *
      *   The value of WSDL_AUTH_NTLM must match the
      *   value of HTTP_AUTH_NTLM. WSDL_AUTH_NTLM has
      *   beend defined to compile the stub with
      *   with the original and unpatched HTTPAPI
      *   service program.
     D WSDL_AUTH_NTLM...
     D                 C                   '3'
      *
     D WSDL_AUTH_TYPE_HTTP...
     D                 C                   '*HTTP'
     D WSDL_AUTH_TYPE_PROXY...
     D                 C                   '*PROXY'
      *
      *   HTTP header:
     D cHTTP_HEADER_CONTENT_TYPE...
     D                 C                   'Content-Type'
     D cHTTP_HEADER_SOAP_ACTION...
     D                 C                   'SOAPAction'
      *
     D wsdl_userAgent_t...
     D                 S            256A   varying                 based(pDummy)
      *
     D wsdl_proxy_t...
     D                 DS                  qualified               based(pDummy)
     D  server                      256A
     D  port                         10I 0
      *
     D wsdl_httpDebug_t...
     D                 DS                  qualified               based(pDummy)
     D  status                         N
     D  fileName                    500A   varying
      *
     D wsdl_fullElementData_t...
     D                 DS                  qualified               based(pDummy)
     D   pData                         *
     D   size                        10I 0
      *
     D headers_t...
     D                 DS                  qualified               based(pDummy)
     D  contentType                        like(wsdl_contentType_t)
     D  soapAction                         like(wsdl_soapAction_t )
      *
      *   SOAP types:
     D wsdl_errors_t...
     D                 DS                  qualified               based(pDummy)
     D  errType                      10I 0
     D  httpError                          likeds(wsdl_httpError_t  )
     D  soapFault                          likeds(wsdl_soapFault_t  )
     D  xmlError                           likeds(wsdl_xmlError_t   )
      *
     D wsdl_httpError_t...
     D                 DS                  qualified               based(pDummy)
     D  no                                 like(wsdl_http_ErrorNo_t   )
     D  text                               like(wsdl_http_ErrorText_t )
      *
     D wsdl_soapFault_t...
     D                 DS                  qualified               based(pDummy)
     D  code                               like(wsdl_soap_faultcode_t    )
     D  string                             like(wsdl_soap_faultstring_t  )
     D  detail                             likeds(wsdl_soap_faultDetail_t)
      *
     D wsdl_soap_faultDetail_t...
     D                 DS                  qualified               based(pDummy)
     D  hostname                    256A   varying
      *
     D wsdl_xmlError_t...
     D                 DS                  qualified               based(pDummy)
     D  code                               like(wsdl_xml_ErrorNo_t    )
     D  text                               like(wsdl_xml_ErrorText_t  )
     D  line                               like(wsdl_xml_line_t       )
     D  column                             like(wsdl_xml_column_t     )
      *
      *  Attachment ID as specified in an attachment part of a MIME message
     D wsdl_attachmentID_t...
     D                 S            254A   varying                 based(pDummy)
      *
      *  Holds the content type of a ManagedMemoryDataSource or AttachmentPart.
     D wsdl_contentType_t...
     D                 S           1024A   varying                 based(pDummy)
      *
      *  Path name of a IFS stream file.
     D wsdl_path_t...
     D                 S            254A   varying                 based(pDummy)
     D wsdl_pathLong_t...
     D                 S           1024A   varying                 based(pDummy)
      *
      *  Attachment
     D wsdl_attachment_t...
     D                 DS                  qualified               based(pDummy)
     D  ID                                 like(wsdl_attachmentID_t )
     D  fileName                           like(wsdl_path_t         )
      *
      *  General purpose UUID
     D wsdl_uuid_t...
     D                 S             32A                           based(pDummy)
      *
      *  Name of the web service port
     D wsdl_portName_t...
     D                 S            512A   varying                 based(pDummy)
      *
      *  Name of the web service operation
     D wsdl_operName_t...
     D                 S            512A   varying                 based(pDummy)
      *
      *  Marshaller/Unmarshaller constants
     D WSDL_LOCAL_TIMEZONE...
     D                 C                   '*LOCAL'
     D WSDL_NO_TIMEZONE...
     D                 C                   '*NONE'
      *
      *  Structure to hold a qualified job name
     D wsdl_qJob_t     DS                  qualified           based(pDummy)
     D  name                         10A
     D  user                         10A
     D  nbr                           6A
      *
      *  Marshaller/Unmarshaller data types
     D wsdl_decimal_t...
     D                 S             31S15                         based(pDummy)
     D wsdl_double_t...
     D                 S                   like(wsdl_decimal_t )   based(pDummy)
      *
     D wsdl_duration_t...
     D                 DS                  qualified               based(pDummy)
     D  isNegative                     N
     D  years                        10I 0
     D  months                       10I 0
     D  days                         10I 0
     D  hours                        10I 0
     D  minutes                      10I 0
     D  seconds                      10I 0
      *
     D wsdl_float_t...
     D                 S                   like(wsdl_decimal_t )   based(pDummy)
     D wsdl_int_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_integer_t...
     D                 S             20I 0                         based(pDummy)
     D wsdl_long_t...
     D                 S             20I 0                         based(pDummy)
     D wsdl_negInt_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_nonNegInt_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_nonPosInt_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_posInt_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_short_t...
     D                 S              5I 0                         based(pDummy)
     D wsdl_byte_t...
     D                 S              3I 0                         based(pDummy)
     D wsdl_uInt_t...
     D                 S             10U 0                         based(pDummy)
     D wsdl_uLong_t...
     D                 S             20U 0                         based(pDummy)
     D wsdl_uShort_t...
     D                 S              5U 0                         based(pDummy)
     D wsdl_uByte_t...
     D                 S              3U 0                         based(pDummy)
      *
     D wsdl_gDay_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_gMonth_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_gMonthDay_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_gYear_t...
     D                 S             10I 0                         based(pDummy)
     D wsdl_gYearMonth_t...
     D                 S             10I 0                         based(pDummy)
      *
      /ENDIF
